import serial
import plotly.plotly as py
import json
import time
import os
import datetime
from time import sleep
from plotly.graph_objs import Scatter, Layout, Figure, Data, Stream, YAxis, Marker

ser = serial.Serial('/dev/ttyACM0',9600,timeout=0)
pointer = [0,1,2,3,4] #pointer penanda ;
sensor = [0,1,2,3,4] #nilai masing" sensor

with open('./config.json') as config_file:
    plotly_user_config = json.load(config_file)

py.sign_in('your_plotly_username', 'your_api_key')

Pressure = Scatter(
    x=[],
    y=[],
    name=u'Pressure',
    marker=Marker(
        color=u'rgb(222, 113, 88)',
	symbol='square'
    ),
    
    stream=Stream(
        token='your_token_key',
        maxpoints=100
    ),
    yaxis='y'
)

HumiditySoil = Scatter(
    x=[],
    y=[],
    name=u'Humidity(Soil)',
    marker=Marker(
        color=u'rgb(84, 172, 234)',
	symbol='square'
    ),
    stream=Stream(
        token='your_token_key',
        maxpoints=100
    ),
    yaxis='y2'
)
HumidityAir = Scatter(
    x=[],
    y=[],
    name=u'Humidity(Air)',
    stream=Stream(
        token='your_token_key',
        maxpoints=100
    ),
    yaxis='y3'
)

Temperature = Scatter(
    x=[],
    y=[],
    name=u'Temperature',
    stream=Stream(
        token='your_token_key',
        maxpoints=100
    ),
    yaxis='y4'
)
RainDrop = Scatter(
    x=[],
    y=[],
    name=u'Rain Drop',
    stream=Stream(
        token='your_token_key',
        maxpoints=100
    ),
    yaxis='y5'
)
data = Data([Pressure,HumiditySoil,HumidityAir,Temperature,RainDrop])

layout = Layout(
   title='Automatic Weather Station (AWS) Graph',
   xaxis=dict(
       domain=[0.15,0.7]
   ),
   yaxis=YAxis(
      title='(Pressure)mhPa',
      titlefont=dict(
          color='#cc66ff'
      ),
      tickfont=dict(
          color='#cc66ff'
      ),
      range=[0,1500],
      position=0,
      ),
   yaxis2=YAxis(
      title='(Soil Humidity) %',
      titlefont=dict(
          color='#9467bd'
      ),
      tickfont=dict(
          color='#9467bd'
      ),
      anchor='free',
      position=1,
      overlaying='y',
      side='right',
      range=[0,100]),
   yaxis3=YAxis(
      title='(Air Humidity) %',
      titlefont=dict(
          color='#1f77b4'
      ),
      tickfont=dict(
          color='#1f77b4'
      ),
      overlaying='y',
      side='right',
      range=[0,100],
      position=0.90),
   yaxis4=YAxis(
      title='(Temperature) C',
      titlefont=dict(
          color='#ff7f0e'
      ),
      tickfont=dict(
          color='#ff7f0e'
      ),
      anchor='free',
      overlaying='y',
      side='left',
      range=[0,100],
      position=0.10),
   yaxis5=YAxis(
      title='(Rain Drop) %',
      titlefont=dict(
          color='#d62728'
      ),
      tickfont=dict(
          color='#d62728'
      ),
      anchor='free',
      overlaying='y',
      side='right',
      range=[0,100],
      position=0.80))

try:
    fig = Figure(data=data, layout=layout)
    url = py.plot(fig, filename='raspberry-temp-humi-stream')
    print ("View your streaming graph here: ", url)

    stream_1 = py.Stream('your_token_key')
    stream_1.open()
    stream_2 = py.Stream('your_token_key')
    stream_2.open()
    stream_3 = py.Stream('your_token_key')
    stream_3.open()
    stream_4 = py.Stream('your_token_key')
    stream_4.open()
    stream_5 = py.Stream('your_token_key')
    stream_5.open()
except:
    print('Connections went wrong! Can\'t tell what?')

while True:
    i = 0
    counter = 0
    read_serial=ser.readline()
    for i in range(len(read_serial)):
#    for i in range(17):
        if read_serial[i]==";":
            pointer[counter]=i
            counter = counter + 1
    try:
        sensor[0]=str(int(read_serial[0:pointer[0]],16))
        sensor[1]=str(int(read_serial[(pointer[0]+1):pointer[1]],16))
        sensor[2]=str(int(read_serial[(pointer[1]+1):pointer[2]],16))
        sensor[3]=str(int(read_serial[(pointer[2]+1):pointer[3]],16))
        sensor[4]=str(int(read_serial[(pointer[3]+1):pointer[4]],16))
        stream_2.write({'x': datetime.datetime.now(), 'y': int(read_serial[0:pointer[0]],16)})
        stream_5.write({'x': datetime.datetime.now(), 'y': int(read_serial[(pointer[0]+1):pointer[1]],16)})
        stream_1.write({'x': datetime.datetime.now(), 'y': int(read_serial[(pointer[1]+1):pointer[2]],16)})
        stream_3.write({'x': datetime.datetime.now(), 'y': int(read_serial[(pointer[2]+1):pointer[3]],16)})
        stream_4.write({'x': datetime.datetime.now(), 'y': int(read_serial[(pointer[3]+1):pointer[4]],16)})
        file = open("/home/pi/Desktop/AWS_log.csv", "a")
        if os.stat("/home/pi/Desktop/AWS_log.csv").st_size == 0:
            file.write("Time,Soil Humifity,Rain Drop,Pressure,Air Humidity,Temperature\n")
        now = datetime.datetime.now()
        file.write(str(now)+","+sensor[0]+","+sensor[1]+","+sensor[2]+","+sensor[3]+","+sensor[4]+"\n")
        file.flush()
        try :
            file1 = open("/media/SD CARD/AWS_log.csv", "a")
            if os.stat("/media/SD CARD/AWS_log.csv").st_size == 0 :
                file1.write("Time,Soil Humifity,Rain Drop,Pressure,Air Humidity,Temperature\n")
            file1.write(str(now)+","+sensor[0]+","+sensor[1]+","+sensor[2]+","+sensor[3]+","+sensor[4]+"\n")
            file1.flush()
        except:
            print('Data Logging went wrong! Can\'t tell what?')
    except:
        print('Something went wrong! Can\'t tell what?')
    time.sleep(60)
    print sensor[0]
    print sensor[1]
    print sensor[2]
    print sensor[3]
    print sensor[4]
    print str(datetime.datetime.now())
    print read_serial
stream_1.close()
stream_2.close()
stream_3.close()
stream_4.close()
stream_5.close()

